From 364f0d9d62c18791386a11ed5715cc569bb78ff8 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 6 Aug 2021 16:49:56 +0000
Subject: [PATCH] [arm64] port ssim_4x4x2_core

       ssim_4x4x2_core	31.03x 	 13.32    	 413.45
---
 source/common/aarch64/asm-primitives.cpp |  3 ++
 source/common/aarch64/pixel-util.S       | 60 ++++++++++++++++++++++++
 2 files changed, 63 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 2c5ab6c..1631c0e 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -54,6 +54,9 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
 {
     if (cpuMask & X265_CPU_NEON)
     {
+        // ssim_4x4x2_core
+        p.ssim_4x4x2_core = PFX(ssim_4x4x2_core_neon);
+
         // addAvg
          p.pu[LUMA_4x4].addAvg[NONALIGNED]   = PFX(addAvg_4x4_neon);
          p.pu[LUMA_4x8].addAvg[NONALIGNED]   = PFX(addAvg_4x8_neon);
diff --git a/source/common/aarch64/pixel-util.S b/source/common/aarch64/pixel-util.S
index f0a2ffe..c6f5e25 100644
--- a/source/common/aarch64/pixel-util.S
+++ b/source/common/aarch64/pixel-util.S
@@ -1676,6 +1676,66 @@ function x265_dequant_normal_neon
     ret
 endfunc
 
+/********* ssim ***********/
+// void ssim_4x4x2_core(const pixel* pix1, intptr_t stride1, const pixel* pix2, intptr_t stride2, int sums[2][4])
+function x265_ssim_4x4x2_core_neon
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x0], x1
+    ld1             {v2.8b}, [x0], x1
+    ld1             {v3.8b}, [x0], x1
+
+    ld1             {v4.8b}, [x2], x3
+    ld1             {v5.8b}, [x2], x3
+    ld1             {v6.8b}, [x2], x3
+    ld1             {v7.8b}, [x2], x3
+
+    umull           v16.8h, v0.8b, v0.8b
+    umull           v17.8h, v1.8b, v1.8b
+    umull           v18.8h, v2.8b, v2.8b
+    uaddlp          v30.4s, v16.8h
+    umull           v19.8h, v3.8b, v3.8b
+    umull           v20.8h, v4.8b, v4.8b
+    umull           v21.8h, v5.8b, v5.8b
+    uadalp          v30.4s, v17.8h
+    umull           v22.8h, v6.8b, v6.8b
+    umull           v23.8h, v7.8b, v7.8b
+
+    umull           v24.8h, v0.8b, v4.8b
+    uadalp          v30.4s, v18.8h
+    umull           v25.8h, v1.8b, v5.8b
+    umull           v26.8h, v2.8b, v6.8b
+    umull           v27.8h, v3.8b, v7.8b
+    uadalp          v30.4s, v19.8h
+
+    uaddl           v28.8h, v0.8b, v1.8b
+    uaddl           v29.8h, v4.8b, v5.8b
+    uadalp          v30.4s, v20.8h
+    uaddlp          v31.4s, v24.8h
+
+    uaddw           v28.8h, v28.8h, v2.8b
+    uaddw           v29.8h, v29.8h, v6.8b
+    uadalp          v30.4s, v21.8h
+    uadalp          v31.4s, v25.8h
+
+    uaddw           v28.8h, v28.8h, v3.8b
+    uaddw           v29.8h, v29.8h, v7.8b
+    uadalp          v30.4s, v22.8h
+    uadalp          v31.4s, v26.8h
+
+    uaddlp          v28.4s, v28.8h
+    uaddlp          v29.4s, v29.8h
+    uadalp          v30.4s, v23.8h
+    uadalp          v31.4s, v27.8h
+
+    addp            v28.4s, v28.4s, v28.4s
+    addp            v29.4s, v29.4s, v29.4s
+    addp            v30.4s, v30.4s, v30.4s
+    addp            v31.4s, v31.4s, v31.4s
+
+    st4             {v28.2s, v29.2s, v30.2s, v31.2s}, [x4]
+    ret
+endfunc
+
 // int psyCost_pp(const pixel* source, intptr_t sstride, const pixel* recon, intptr_t rstride)
 function x265_psyCost_4x4_neon
     ld1r            {v4.2s}, [x0], x1
-- 
2.25.1

